php-cgi is version 5.6 no matter what

Discussion in 'ISPConfig 3 Priority Support' started by Taleman, Feb 24, 2021.

  1. Taleman

    Taleman Well-Known Member HowtoForge Supporter

    On one host upgraded from Debian 9 to Debian 10 and ISPConfig 3.1.15 to 3.2.2 htf-report show version check
    Code:
    ##### VERSION CHECK #####
    
    [INFO] php (cli) version is 7.3.27-9+0~20210223.81+debian10~1.gbpa4a3d6
    [INFO] php-cgi (used for cgi php in default vhost!) is version 5.6.40-0+deb8u2
    
    I have not managed to make it show PHP 7.3 for php-cgi. Services seem to work though, so I wonder if that message is in error?
    I have checked PHPMyAdmin uses PHP version 7.3:
    Code:
    PHP:n versio: 7.3.27-9+0~20210223.81+debian10~1.gbpa4a3d6
    I just noticed I had forgotten to add to Additional PHP versions buster default PHP 7.3 after upgrading to buster. Added now, but htf-common-issues still shows php-cgi 5.6.
    I did what @Jesse Norell suggested in https://www.howtoforge.com/community/threads/phpmyadmin-broken-syntax-error.85997/#post-415161 but no change.
    PHP settings now, screenshot: Looks like embedding screenshot does not work, so here is link to image file: http://taleman.fi/Kuvia/PHP-settings.png
     
  2. till

    till Super Moderator Staff Member ISPConfig Developer

    Try to run this command:

    Code:
    update-alternatives --config php-cgi
    and choose php 7.3 as default version.
     
  3. Taleman

    Taleman Well-Known Member HowtoForge Supporter

    7.3 is already the chosen one.
    Code:
    [email protected]:/tmp# update-alternatives --config php-cgi
    There are 5 choices for the alternative php-cgi (providing /usr/bin/php-cgi).
    
      Selection    Path                 Priority   Status
    ------------------------------------------------------------
      0            /usr/bin/php-cgi7.3   73        auto mode
      1            /usr/bin/php-cgi5.6   56        manual mode
      2            /usr/bin/php-cgi7.0   70        manual mode
      3            /usr/bin/php-cgi7.2   72        manual mode
    * 4            /usr/bin/php-cgi7.3   73        manual mode
      5            /usr/bin/php5-cgi     50        manual mode
    
    Press <enter> to keep the current choice[*], or type selection number:
    
     
  4. till

    till Super Moderator Staff Member ISPConfig Developer

    Please run this command:

    which php-cgi

    and post the result. Maybe you have a manually compiled php-cgi binary in /usr/local/bin/ folder.
     
  5. Taleman

    Taleman Well-Known Member HowtoForge Supporter

    Code:
    [email protected]:/tmp# which php-cgi
    /usr/bin/php-cgi
    [email protected]:/tmp# ls -lh /usr/bin/php-cgi
    lrwxrwxrwx 1 root root 25 touko   8  2017 /usr/bin/php-cgi -> /etc/alternatives/php-cgi
    [email protected]:/tmp# ls -lh /etc/alternatives/php-cgi
    lrwxrwxrwx 1 root root 19 joulu  30 19:18 /etc/alternatives/php-cgi -> /usr/bin/php-cgi7.3
    [email protected]:/tmp#
    
    Code:
    [email protected]:/tmp# php-cgi -v
    PHP 7.3.27-9+0~20210223.81+debian10~1.gbpa4a3d6 (cgi-fcgi) (built: Feb 23 2021 16:47:00)
    Copyright (c) 1997-2018 The PHP Group
    Zend Engine v3.3.27, Copyright (c) 1998-2018 Zend Technologies
        with Zend OPcache v7.3.27-9+0~20210223.81+debian10~1.gbpa4a3d6, Copyright (c) 1999-2018, by Zend Technologies
    [email protected]:/tmp#
    
     
  6. till

    till Super Moderator Staff Member ISPConfig Developer

    Hmm, strange. I'll have to take a look into the test script. You can probably ignore the test script result in this case.
     
  7. Th0m

    Th0m ISPConfig Developer Staff Member ISPConfig Developer

    Could you create a PHP info file with a web that runs the default version in FastCGI mode, and see what it shows?
     
  8. Taleman

    Taleman Well-Known Member HowtoForge Supporter

    Code:
    PHP Version 7.3.27-9+0~20210223.81+debian10~1.gbpa4a3d6
    System    Linux mail 4.19.0-14-amd64 #1 SMP Debian 4.19.171-2 (2021-01-30) x86_64
    Build Date    Feb 23 2021 16:47:00
    Server API    CGI/FastCGI
    Virtual Directory Support    disabled
    Configuration File (php.ini) Path    /etc/php/7.3/cgi
    Loaded Configuration File    /etc/php5/cgi/php.ini
    Scan this dir for additional .ini files    /etc/php/7.3/cgi/conf.d
    There is Loaded Configuration File /etc/php5/cgi/php.ini
    Wonder where that comes from?
     
  9. Th0m

    Th0m ISPConfig Developer Staff Member ISPConfig Developer

    Should be nothing to worry about then. Maybe the error is caused because of
    Code:
    Loaded Configuration File    /etc/php5/cgi/php.ini
     
  10. Taleman

    Taleman Well-Known Member HowtoForge Supporter

    I found in file /var/www/php-fcgi-scripts/web19/.php-fcgi-starter
    Code:
    #!/bin/sh
    PHPRC="/etc/php5/cgi/"
    export PHPRC
    PHP_DOCUMENT_ROOT="/var/www/clients/client1/web19"
    
    I think that causes the Loaded Configuration File /etc/php5/cgi/php.ini
    I checked other websites, there is for example PHPRC="/etc/php/7.2/cgi/"
    Maybe some template for websites in messed up on this host?
     
  11. Jesse Norell

    Jesse Norell ISPConfig Developer Staff Member ISPConfig Developer

    Maybe this has something to the updating. Did you resync websites after updating? Did this site run php 5.x and was just changed? If you switch php versions, does the file get rewritten correctly?

    That particular website issue should be unrelated to the test script output, but something is obviously awry.

    One idea - did you update the php settings in server config for your new system php version?
     
  12. Taleman

    Taleman Well-Known Member HowtoForge Supporter

    The /client1/web19 website I created just now, for this testing. The host has been upgraded from Jessie to Stretch to Buster, I suspect this upgrading has caused this PHP 5.6 problem.
    For that website I changed PHP to 7.2. That fixed the
    Code:
    Loaded Configuration File    /etc/php/7.2/fpm/php.ini
    version mismatch. But common-issues still reports
    Code:
    [INFO] php-cgi (used for cgi php in default vhost!) is version 5.6.40-0+deb8u2
     
  13. Taleman

    Taleman Well-Known Member HowtoForge Supporter

    I did, but now I notice there is tab for FastCGI, where
    Code:
    FastCGI php.ini Path: /etc/php5/cgi/
    Should this be /etc/php/7.3/cgi/ ?
     
    ahrasis likes this.
  14. Jesse Norell

    Jesse Norell ISPConfig Developer Staff Member ISPConfig Developer

    Yes, all paths need updated; see if that fixes what the test script reports as well.
     
  15. Taleman

    Taleman Well-Known Member HowtoForge Supporter

    Changed and remembered to write / in the end of /etc/php/7.3/cgi/ . But test script continues to show
    Code:
    ##### VERSION CHECK #####
    
    [INFO] php (cli) version is 7.3.27-9+0~20210223.81+debian10~1.gbpa4a3d6
    [INFO] php-cgi (used for cgi php in default vhost!) is version 5.6.40-0+deb8u2
    
     
  16. Jesse Norell

    Jesse Norell ISPConfig Developer Staff Member ISPConfig Developer

    This is a bug in the htf-common-issues.php script, it actually tests for only the hardcoded path /usr/lib/cgi-bin/php5 and runs that to get the version number:
    Code:
    if(is_file('/usr/lib/cgi-bin/php5') || is_link('/usr/lib/cgi-bin/php5')) {
            $check = shell_exec('/usr/lib/cgi-bin/php5 -v');
    ....
    
     
    ahrasis and till like this.
  17. Th0m

    Th0m ISPConfig Developer Staff Member ISPConfig Developer

    I have opened a issue for it: https://gitplace.net/pixcept/ispconfig-tools/-/issues/3
     

Share This Page